
#include <avr/io.h>
#include <avr/delay.h>
#include <avr/pgmspace.h>
#include "MAIN.h"
#include "MISC.h"
#include "3310LCD.h"
#include "english_6x8_pixel.h"

/*-----------------------------------------------------------------------
LCD_init          : 3310LCDʼ
-----------------------------------------------------------------------*/
void LCD_init(void)
{
    PORTB &=~(1<<LCD_nRST);		// һLCDλĵ͵ƽ
    _delay_loop_2(1000*FREQ/4);
    PORTB |= (1<<LCD_nRST);

    PORTB &=~(1<<LCD_nCE);			// رLCD
    _delay_loop_2(10*FREQ/4);
    PORTB |= (1<<LCD_nCE);			// ʹLCD

    LCD_write_byte(0x21, 0);		// ʹչLCDģʽ
    LCD_write_byte(0x80+0x48, 0);	// ƫõѹ
    LCD_write_byte(0x04+0x02, 0);	// ¶У
    LCD_write_byte(0x10+0x03, 0);	// 1:48
    LCD_write_byte(0x20, 0);  		// ʹû
    LCD_clear();		 			// 
    LCD_write_byte(0x0c, 0);		// 趨ʾģʽʾ
    PORTB &= ~(1<<LCD_nCE);        // رLCD
}

/*-----------------------------------------------------------------------
LCD_clear         : LCD
 
д          2004-8-10 
޸      2004-8-10 
-----------------------------------------------------------------------*/
void LCD_clear(void)
{
    unsigned int i;
    LCD_write_byte(0x0c, 0);
    LCD_write_byte(0x80, 0);
    for (i=0; i<504; i++)
        LCD_write_byte(0, 1);
}

/*-----------------------------------------------------------------------
LCD_set_XY        : LCD꺯
 
X       083
          Y       05
 
д          2004-8-10 
޸      2004-8-10 
-----------------------------------------------------------------------*/
void LCD_set_XY(unsigned char X, unsigned char Y)
{
    LCD_write_byte(0x40 | Y, 0);		// column
    LCD_write_byte(0x80 | X, 0);          	// row
}

/*-----------------------------------------------------------------------
LCD_write_char    : ʾӢַ
 
c       ʾַ
 
д          2004-8-10 
޸      2004-8-10 
-----------------------------------------------------------------------*/
void LCD_write_char(unsigned char c)
{
    unsigned char line;
    const unsigned char *map= &font6x8[0][0];
    c -= 32;
    map+=c*6;
    line=6;
    while (line--)
        LCD_write_byte(pgm_read_byte(map++), 1);
}
/*-----------------------------------------------------------------------
LCD_write_english_String  : Ӣַʾ
 
*s      Ӣַָ룻
          XY    : ʾַλ,x 0-83 ,y 0-5
 
д          2004-8-10 
޸      2004-8-10 		
-----------------------------------------------------------------------*/
void LCD_write_english_string(unsigned char X,unsigned char Y,unsigned char *s)
{
    LCD_set_XY(X,Y);
    while (*s)
    {
        LCD_write_char(*s);
        s++;
    }
}

/*-----------------------------------------------------------------------
LCD_write_byte    : ʹSPIӿдݵLCD
 
data    дݣ
          command д/ѡ
-----------------------------------------------------------------------*/
void LCD_write_byte(unsigned char data, unsigned char command)
{
    PORTB&=~(1<<LCD_nCE) ;			// ʹLCD
    if (command==0)
        PORTB&=~(1<<LCD_DnC);	// 
    else
        PORTB|= (1<<LCD_DnC);	// 
    SPDR=data;			 		// ݵSPIĴ
    while ((SPSR & (1<<SPIF)) == 0)
        ;		// ȴݴ
    PORTB|= (1<<LCD_nCE) ;			// رLCD
}

//дȫ
void LCD_draw_Screen(const unsigned char *map)
{
    unsigned int i;
    LCD_set_XY(0,0);
    for(i=0; i<504; i++)
    {
        LCD_write_byte(pgm_read_byte(map++), 1);
    }
}

