#include <avr/io.h>
#include <avr/delay.h>
#include "MAIN.h"
#include "TWI.h"
#include "MISC.h"

unsigned char IIC_SLA=0x00;

/*************ģʽTWI*************ʼ**************/

//ֹͣ
void twi_stop(void)
{
    TWCR = (1<<TWINT) |(1<<TWSTO) | (1<<TWEN);
}
//𶯿ʼ
unsigned char twi_start(void)
{
    TWCR = (1<<TWINT) |(1<<TWSTA) | (1<<TWEN);
    while ((TWCR & (1<<TWINT)) == 0)
        ;
    return TW_STATUS;
}

//дһֽ
unsigned char twi_writebyte(unsigned char c)
{
    TWDR = c;
    TWCR = (1<<TWINT) | (1<<TWEN);
    while ((TWCR & (1<<TWINT)) == 0)
        ;
    return TW_STATUS;
}

//һֽ ack: trueʱACKfalseʱNACK
unsigned char twi_readbyte(unsigned char *ptr ,unsigned char ack)
{
    unsigned char tmp=(1<<TWINT)|(1<<TWEN);

    if(ack)
	{
		tmp|=(1<<TWEA);
	}
    TWCR=tmp;
    while ((TWCR & (1<<TWINT)) == 0);
    *ptr=TWDR;
    return TW_STATUS;
}
/*************ģʽTWI***************************/

/*************IIC**************ʼ**************/
//IICڴд
unsigned char rtc_write(unsigned char addr,unsigned char *buf,unsigned char len)
{
    unsigned char i;

    twi_start();
    twi_writebyte(IIC_SLA|TW_WRITE);
    twi_writebyte(addr);//write address
    for(i=0;i<len;i++)
        twi_writebyte(buf[i]);
    twi_stop();
    return 0;
}

//IICڴĶ
unsigned char rtc_read(unsigned char addr,unsigned char *buf,unsigned char len)
{
    unsigned char i;

    rtc_write(addr,0,0);//set address
    _delay_loop_2(1000);
    twi_start();
    twi_writebyte(IIC_SLA|TW_READ);
    for(i=0;i<len-1;i++)
        twi_readbyte(buf+i,TW_ACK);
    twi_readbyte(buf+i,TW_NACK);
    twi_stop();
    return 0;
}
/*************ӿڲ*****************************/
